use "C:\Users\Erik Liahjell Saue\Desktop\Økonomi, HHiT\Siv.øk\5. år\Vårsemester\Masteroppgåve\Data masteroppgave\Endelige data\Endelige data 2007_2019.dta" 

/// Sjekker om ln-variablene er I(1) på nivåform ///
dfuller lnNP, trend lags(2)
dfuller lnElGer , trend lags(2)
dfuller lnCo2 , trend lags(2)
dfuller lnCoal , trend lags(2)
dfuller lnBrent , trend lags(2)
dfuller lnGas , trend lags(2)

/// Sjekker om variablene er I(1) på nivåform ///
dfuller ElNordPool, trend lags(2)
dfuller ElGer , trend lags(2)
dfuller Co2 , trend lags(2)
dfuller Coal , trend lags(2)
dfuller Brent , trend lags(2)
dfuller Gas , trend lags(2)

/// Sjekker om variablene er I(0) ///
dfuller d.lnNP, lags(2)
dfuller d.lnElGer , lags(2)
dfuller d.lnCo2 , lags(2)
dfuller d.lnCoal , lags(2)
dfuller d.lnBrent , lags(2)
dfuller d.lnGas , lags(2)

/// Sjekker Ljung-Box for autokorrelasjon i log-priser ///
wntestq lnNP, lags(10)
wntestq lnElGer , lags(10)
wntestq lnCo2 , lags(10)
wntestq lnCoal , lags(10)
wntestq lnBrent , lags(10)
wntestq lnGas , lags(10)

/// Sjekker Ljung-Box for autokorrelasjon i priser ///
wntestq ElNordPool, lags(10)
wntestq ElGer , lags(10)
wntestq Co2 , lags(10)
wntestq Coal , lags(10)
wntestq Brent , lags(10)
wntestq Gas , lags(10)

/// Sjekker Ljung-Box for autokorrelasjon i diff. log-priser ///
wntestq d.lnNP , lags(10)
wntestq d.lnElGer , lags(10)
wntestq d.lnCo2 , lags(10)
wntestq d.lnCoal , lags(10)
wntestq d.lnBrent , lags(10)
wntestq d.lnGas , lags(10)


/// Deskriptiv statistikk for priser og log-priser ///
summarize ElNordPool ElGer Co2 Coal Brent Gas, detail
summarize lnNP lnElGer lnCo2 lnCoal lnBrent lnGas, detail
summarize d.lnNP d.lnElGer d.lnCo2 d.lnCoal d.lnBrent d.lnGas, detail


/// ENGLE-GRANGER-METODEN ///

/// Sjekker om det finne bivariate kointegrerende sammenhenger ///
* res_Y_X betyr residual fra regresjon med variabel Y som avh. og X som uavh.

dfuller res_ElNP_ElGer, lags(2)
dfuller res_ElNP_Co2 , lags(2)
dfuller res_ElNP_Coal, lags(2)
dfuller res_ElNP_Brent, lags(2)
dfuller res_ElNP_Gas, lags(2)

dfuller res_ElGer_Co2 , lags(2)
dfuller res_ElGer_Coal , lags(2)
dfuller res_ElGer_Brent , lags(2)
dfuller res_ElGer_Gas , lags(2)

dfuller res_Co2_Coal , lags(2)
dfuller res_Co2_Brent , lags(2)
dfuller res_Co2_Gas , lags(2)

dfuller res_Coal_Brent , lags(2)
dfuller res_Coal_Gas , lags(2)

dfuller res_Brent_Gas , lags(2)


/// Lager bivariate error correction models (ECM) for ElNP og ElGer ///

* ECM ElNP
reg d.ElNordPool d.L1.ElNordPool d.L1.ElGer L1.res_ElNP_ElGer

* Sjekker ECM for autokorrelasjon vba Durbin-Watson
estat dwatson

* Sjekker ECM for autokorrelasjon vba Lagrange Multiplier-testen
estat bgodfrey, lags(2)

* ECM ElGer
reg d.ElGer d.L1.ElNordPool d.L1.ElGer d2.L1.ElGer L1.res_ElNP_ElGer

* Sjekker ECM for autokorrelasjon vba Durbin-Watson
estat dwatson

* Sjekker ECM for autokorrelasjon vba Lagrange Multiplier-testen
estat bgodfrey, lags(2)


/// JOHANSEN OG JUSELIUS-METODEN ///

/// Sjekker antall kointegrerende vektorer med ett lag ///
vecrank lnGas lnBrent lnCoal lnCo2 lnElGer lnNP, trend(constant)

/// Kjører VECM-modell med antall rang anbefalt av rangtesten ///
vec lnElGer lnCoal lnBrent lnGas lnCo2 lnNP, trend(constant) rank(3)

/// Har sjekket for autokorrelasjon vba veclmar-test. Viser AK med ett lag i VECM-modell, men
*   koeffisientene er stort sett like når vi kjører med to lags og unngår AK
